=== CHOLMOD/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# SuiteSparse/CHOLMOD/CMakeLists.txt:  cmake for CHOLMOD
#-------------------------------------------------------------------------------

# CHOLMOD: Copyright (c) 2005-2023, Timothy A. Davis.
# Copyright and license varies by module.

#-------------------------------------------------------------------------------
# get the version
#-------------------------------------------------------------------------------

# cmake 3.22 is required to find the BLAS/LAPACK
cmake_minimum_required ( VERSION 3.22 )

set ( CHOLMOD_DATE "July 25, 2025" )
set ( CHOLMOD_VERSION_MAJOR 5 CACHE STRING "" FORCE )
set ( CHOLMOD_VERSION_MINOR 3 CACHE STRING "" FORCE )
set ( CHOLMOD_VERSION_SUB   4 CACHE STRING "" FORCE )

message ( STATUS "Building CHOLMOD version: v"
    ${CHOLMOD_VERSION_MAJOR}.
    ${CHOLMOD_VERSION_MINOR}.
    ${CHOLMOD_VERSION_SUB} " (" ${CHOLMOD_DATE} ")" )

#-------------------------------------------------------------------------------
# define the project
#-------------------------------------------------------------------------------

project ( CHOLMOD
        VERSION "${CHOLMOD_VERSION_MAJOR}.${CHOLMOD_VERSION_MINOR}.${CHOLMOD_VERSION_SUB}"
        LANGUAGES C )

#-------------------------------------------------------------------------------
# SuiteSparse policies
#-------------------------------------------------------------------------------

set ( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    ${PROJECT_SOURCE_DIR}/cmake_modules
    ${PROJECT_SOURCE_DIR}/../SuiteSparse_config/cmake_modules )

include ( SuiteSparsePolicy )

option ( CHOLMOD_USE_CUDA "ON (default): enable CUDA acceleration for CHOLMOD, OFF: do not use CUDA" ${SUITESPARSE_USE_CUDA} )
if ( NOT SUITESPARSE_USE_CUDA )
    set ( CHOLMOD_USE_CUDA "OFF" CACHE STRING "" FORCE )
endif ( )

option ( CHOLMOD_GPL "ON (default): enable GPL-licensed modules, OFF: do not use any CHOLMOD GPL-licensed modules" ON )
if ( NOT CHOLMOD_GPL )
    # CHOLMOD_GPL: if OFF, do not include any GPL-licensed module
    set ( CHOLMOD_MATRIXOPS OFF )
    set ( CHOLMOD_MODIFY OFF )
    set ( CHOLMOD_SUPERNODAL OFF )
    set ( CHOLMOD_USE_CUDA "OFF" CACHE STRING "" FORCE ) # OK: disabled by user-setting of CHOLMOD_GPL
    add_compile_definitions ( NGPL )
endif ( )

include ( CheckTypeSize )
check_type_size ( "ssize_t" SSIZE_T )
if ( NOT HAVE_SSIZE_T )
    # #include <sys/types.h> and ssize_t not defined (typically on Windows)
    add_compile_definitions ( NO_SSIZE_T )
endif ( )

#-------------------------------------------------------------------------------
# find CUDA
#-------------------------------------------------------------------------------

if ( SUITESPARSE_HAS_CUDA AND CHOLMOD_USE_CUDA )
    # CHOLMOD with CUDA
    enable_language ( CUDA CXX )
    set ( CHOLMOD_HAS_CUDA ON )
else ( )
    set ( CHOLMOD_HAS_CUDA OFF )
endif ( )

# check for strict usage
if ( SUITESPARSE_USE_STRICT AND CHOLMOD_USE_CUDA AND NOT CHOLMOD_HAS_CUDA )
    message ( FATAL_ERROR "CUDA required for CHOLMOD but not found" )
endif ( )

#-------------------------------------------------------------------------------
# find OpenMP
#-------------------------------------------------------------------------------

option ( CHOLMOD_USE_OPENMP "ON: Use OpenMP in CHOLMOD if available.  OFF: Do not use OpenMP.  (Default: SUITESPARSE_USE_OPENMP)" ${SUITESPARSE_USE_OPENMP} )
if ( CHOLMOD_USE_OPENMP )
    if ( CMAKE_VERSION VERSION_LESS 3.24 )
        find_package ( OpenMP COMPONENTS C )
    else ( )
        find_package ( OpenMP COMPONENTS C GLOBAL )
    endif ( )
else ( )
    # OpenMP has been disabled
    set ( OpenMP_C_FOUND OFF )
endif ( )

if ( CHOLMOD_USE_OPENMP AND OpenMP_C_FOUND )
    set ( CHOLMOD_HAS_OPENMP ON )
else ( )
    set ( CHOLMOD_HAS_OPENMP OFF )
endif ( )
message ( STATUS "CHOLMOD has OpenMP: ${CHOLMOD_HAS_OPENMP}" )

# check for strict usage
if ( SUITESPARSE_USE_STRICT AND CHOLMOD_USE_OPENMP AND NOT CHOLMOD_HAS_OPENMP )
    message ( FATAL_ERROR "OpenMP required for CHOLMOD but not found" )
endif ( )

#-------------------------------------------------------------------------------
# find other library dependencies
#-------------------------------------------------------------------------------

if ( NOT SUITESPARSE_ROOT_CMAKELISTS )
    find_package ( SuiteSparse_config 7.11.0
        PATHS ${CMAKE_SOURCE_DIR}/../SuiteSparse_config/build NO_DEFAULT_PATH )
    if ( NOT TARGET SuiteSparse::SuiteSparseConfig )
        find_package ( SuiteSparse_config 7.11.0 REQUIRED )
    endif ( )

    find_package ( AMD 3.3.4
        PATHS ${CMAKE_SOURCE_DIR}/../AMD/build NO_DEFAULT_PATH )
    if ( NOT TARGET SuiteSparse::AMD )
        find_package ( AMD 3.3.4 REQUIRED )
    endif ( )

    find_package ( COLAMD 3.3.5
        PATHS ${CMAKE_SOURCE_DIR}/../COLAMD/build NO_DEFAULT_PATH )
    if ( NOT TARGET SuiteSparse::COLAMD )
        find_package ( COLAMD 3.3.5 REQUIRED )
    endif ( )
endif ( )

#-------------------------------------------------------------------------------
# find CHOLMOD modules
#-------------------------------------------------------------------------------

# CHOLMOD consists of a suite of modules which can be selected a la carte.  To
# not build a module, simply delete or rename the entire folder before building
# CHOLMOD, or pass the corresponding flag when using cmake:

#   -DCHOLMOD_GPL=0        if OFF: do not build any GPL-licensed module
#                          (MatrixOps, Modify, Supernodal, and GPU modules).
#   -DCHOLMOD_CHECK=0      if OFF: do not build the Check module.
#   -DCHOLMOD_MATRIXOPS=0  if OFF: do not build the MatrixOps module.
#   -DCHOLMOD_CHOLESKY=0   if OFF: do not build the Cholesky module.
#                          This also disables the Supernodal and Modify modules.
#   -DCHOLMOD_MODIFY=0     if OFF: do not build the Modify module.
#   -DCHOLMOD_CAMD=0       if OFF: do not link against CAMD and CCOLAMD.
#                          This also disables the Partition module.
#   -DCHOLMOD_PARTITION=0  if OFF: do not build the Partition module.
#   -DCHOLMOD_SUPERNODAL=0 if OFF: do not build the Supernodal module.

# By default, all the above flags are ON, if not defined explicitly.

    #---------------------------------------------------------------------------
    # Check module
    #---------------------------------------------------------------------------

    option ( CHOLMOD_CHECK "ON (default): use Check Module.  OFF: do not use Check Module" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/Check )
        # Check module does not appear so don't use it
        set ( CHOLMOD_CHECK OFF )
    endif ( )
    if ( NOT CHOLMOD_CHECK )
        # if CHOLMOD_CHECK is OFF: do not build the Check module
        add_compile_definitions ( NCHECK )
    endif ( )

    #---------------------------------------------------------------------------
    # MatrixOps module
    #---------------------------------------------------------------------------

    option ( CHOLMOD_MATRIXOPS "ON (default): use MatrixOps Module.  OFF: do not use MatrixOps Module" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/MatrixOps )
        # MatrixOps module does not appear so don't use it
        set ( CHOLMOD_MATRIXOPS OFF )
    endif ( )
    if ( NOT CHOLMOD_MATRIXOPS )
        # if CHOLMOD_MATRIXOPS is OFF: do not build the Check module
        add_compile_definitions ( NMATRIXOPS )
    endif ( )

    #---------------------------------------------------------------------------
    # Cholesky module: requires AMD, COLAMD
    #---------------------------------------------------------------------------

    option ( CHOLMOD_CHOLESKY "ON (default): use Cholesky Module.  OFF: do not use Cholesky Module" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/Cholesky )
        # Cholesky module does not appear so don't use it
        set ( CHOLMOD_CHOLESKY OFF )
    endif ( )
    if ( NOT CHOLMOD_CHOLESKY )
        # if CHOLMOD_CHOLESKY is OFF: do not build the Cholesky module, and do not
        # build the Supernodal or Modify modules that depend on it.
        set ( CHOLMOD_SUPERNODAL OFF )
        set ( CHOLMOD_MODIFY OFF )
        add_compile_definitions ( NCHOLESKY )
    endif ( )

    #---------------------------------------------------------------------------
    # Modify module: requires Cholesky
    #---------------------------------------------------------------------------

    option ( CHOLMOD_MODIFY "ON (default): use Modify Module.  OFF: do not use Modify Module" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/Modify )
        # Modify module does not appear so don't use it
        set ( CHOLMOD_MODIFY OFF )
    endif ( )
    if ( NOT CHOLMOD_MODIFY )
        # if CHOLMOD_MODIFY is OFF: do not build the Modify module
        add_compile_definitions ( NMODIFY )
    endif ( )

    #---------------------------------------------------------------------------
    # interfaces to CAMD and CCOLAMD
    #---------------------------------------------------------------------------

    option ( CHOLMOD_CAMD "ON (default): use CAMD/CCOLAMD.  OFF: do not use CAMD/CCOLAMD" ON )

    # The CHOLMOD interfaces to CAMD and CCOLAMD are in the Partition module
    # (cholmod_camd, cholmod_ccolamd, cholmod_csymamd).  The Partition module
    # has interfaces to METIS (cholmod_metis, cholmod_nesdis) that require
    # them, but the CAMD and CCOLAMD interfaces do not require METIS.  In the
    # future, the CAMD and CCOLAMD interfaces will be split into their own
    # module to make this dependency more clear.

    if ( CHOLMOD_CAMD AND NOT SUITESPARSE_ROOT_CMAKELISTS )
        # find CAMD and CCOLAMD
        find_package ( CAMD 3.3.5
            PATHS ${CMAKE_SOURCE_DIR}/../CAMD/build NO_DEFAULT_PATH )
        if ( NOT TARGET SuiteSparse::CAMD )
            find_package ( CAMD 3.3.5 )
        endif ( )

        find_package ( CCOLAMD 3.3.5
            PATHS ${CMAKE_SOURCE_DIR}/../CCOLAMD/build NO_DEFAULT_PATH )
        if ( NOT TARGET SuiteSparse::CCOLAMD )
            find_package ( CCOLAMD 3.3.5 )
        endif ( )

        if ( NOT CAMD_FOUND OR NOT CCOLAMD_FOUND )
            # CAMD and/or CCOLAMD not found
            set ( CHOLMOD_CAMD OFF )
        endif ( )
    endif ( )

    if ( NOT CHOLMOD_CAMD )
        # Partition module requires CAMD and CCOLAMD, so if CAMD and CCOLAMD
        # are disabled, then do not build the Partition module
        set ( CHOLMOD_PARTITION OFF )
    endif ( )

    #---------------------------------------------------------------------------
    # Partition module: requires Cholesky, CAMD, CCOLAMD, and METIS
    #---------------------------------------------------------------------------

    option ( CHOLMOD_PARTITION "ON (default): use METIS.  OFF: do not use METIS" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/Partition )
        # Partition module does not appear so don't use it.  Since this folder
        # also includes the CAMD and CCOLAMD interfaces, CHOLMOD_CAMD must be
        # set OFF here as well.
        set ( CHOLMOD_PARTITION OFF )
        set ( CHOLMOD_CAMD OFF )
    endif ( )
    if ( NOT CHOLMOD_PARTITION )
        # if CHOLMOD_PARTITION is OFF: do not build the Partition module
        add_compile_definitions ( NPARTITION )
    endif ( )

    if ( NOT CHOLMOD_CAMD )
        # if CHOLMOD_CAMD is OFF: do not build the CAMD and CCOLAMD interfaces
        add_compile_definitions ( NCAMD )
    endif ( )

    #---------------------------------------------------------------------------
    # Supernodal module: requires Cholesky, BLAS, and LAPACK
    #---------------------------------------------------------------------------

    option ( CHOLMOD_SUPERNODAL "ON (default): use Supernodal Module.  OFF: do not use Supernodal Module" ON )

    if ( NOT EXISTS ${PROJECT_SOURCE_DIR}/Supernodal )
        # Supernodal module does not appear so don't use it
        set ( CHOLMOD_SUPERNODAL OFF )
    endif ( )
