=== debian/changelog ===
suitesparse (1:7.11.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * No-change rebuild for IEEE long double on ppc64el

 -- Graham Inggs <ginggs@debian.org>  Thu, 04 Sep 2025 17:45:05 +0000

suitesparse (1:7.11.0+dfsg-1) unstable; urgency=medium

  [ Sébastien Villemot ]
  * New upstream version 7.11.0+dfsg
  * d/copyright: reflect upstream changes
  * Drop “Rules-Requires-Root: no”, which is now the default
  * Bump S-V to 4.7.2

  [ Helmut Grohne ]
  * Fix FTCBFS: Use gfortran-for-host (Closes: #1107057)
  * Demote more Build-Depends to B-D-I.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 18 Aug 2025 15:56:48 +0200
