=== debian/tests/control ===
Test-Command: python3 SPEX/Python/spex_python_demo.py
Depends: python3-spexpy
Restrictions: superficial
