=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%suitesparse-$1.tar.gz%" \
    https://github.com/DrTimothyAldenDavis/SuiteSparse/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
